%define kmod_name		oracleasm
%define kmod_vendor		redhat
%define kmod_rpm_name		kmod-redhat-oracleasm
%define kmod_driver_version	2.0.8
%define kmod_driver_epoch	8
%define kmod_rpm_release	1.3
%define kmod_kernel_version	4.18.0-240.el8
%define kmod_kernel_version_min	4.18.0-240.el8
%define kmod_kernel_version_dep	4.18.0
%define kmod_kbuild_dir		drivers/block/oracleasm
%define kmod_provides           %{kmod_name} = %{?epoch:%{epoch}:}%{version}-%{release} %{kmod_name}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
%define kmod_install_path	extra/kmod-redhat-oracleasm
%define kernel_pkg		kernel
%define kernel_devel_pkg	kernel-devel
%define kernel_modules_pkg	kernel-modules

%define kmod_rpm_name_ga		%{kmod_rpm_name}-kernel_4_18_0_240

%define kmod_rpm_name_14_1		%{kmod_rpm_name}-kernel_4_18_0_240_14_1
%define kmod_kernel_version_14_1	4.18.0-240.14.1.el8_3

%define kmod_list	%{kmod_rpm_name_ga}:%{kmod_kernel_version}: %{kmod_rpm_name_14_1}:%{kmod_kernel_version_14_1}:%{SOURCE1}

%{!?dist: %define dist .el8_3}
%{!?make_build: %define make_build make}

%define kmod_dist_build_deps redhat-rpm-config kernel-abi-whitelists elfutils-libelf-devel kernel-rpm-macros kmod

Source0:	%{kmod_name}-%{kmod_vendor}-%{kmod_driver_version}.tar.bz2
# Source code patches
Patch0:	0000-Makefile-config-opts.patch
Patch1:	0001-oracleasm-driver-replace-fs_context-with-mount_pseud.patch
Patch2:	0002-oracleasm-driver-make-bio_for_each_segment_all-worki.patch
Patch3:	0003-oracleasm-copy-rhel8-s-bio_map_user_iov.patch

Source1: kernel-devel-%{kmod_kernel_version_14_1}.x86_64.rpm

Source9000: find-requires.ksyms

%define findpat %( echo "%""P" )
# We bundle our own slightly modified version of find-requires.ksyms in order
# to get kernel() Requires: for the kmod versions build against bundled
# kernel-devel packages to be generated properly.
%define __find_requires "%{SOURCE9000}"
%define __find_provides /usr/lib/rpm/redhat/find-provides.ksyms %{kmod_name} %{?epoch:%{epoch}:}%{version}-%{release}
%define sbindir %( if [ -d "/sbin" -a \! -h "/sbin" ]; then echo "/sbin"; else echo %{_sbindir}; fi )
%define dup_state_dir %{_localstatedir}/lib/rpm-state/kmod-dups
%define kver_state_dir %{dup_state_dir}/kver
%define kver_state_file %{kver_state_dir}/%{kmod_kernel_version}.%(arch)
%define dup_module_list %{dup_state_dir}/rpm-kmod-%{kmod_name}-modules

Name:		kmod-redhat-oracleasm
Version:	%{kmod_driver_version}
Release:	%{kmod_rpm_release}.0.1%{?dist}
%if "%{kmod_driver_epoch}" != ""
Epoch:		%{kmod_driver_epoch}
%endif
Summary:	oracleasm kernel module
Group:		System/Kernel
License:	GPLv2
URL:		https://github.com/oracle/linux-uek/tree/uek6/master/drivers/block/oracleasm
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires:	%{kmod_dist_build_deps}
# For unpacking bundled kernel-devel packages
BuildRequires:	rpm cpio
ExclusiveArch:	x86_64

%global _use_internal_dependency_generator 0
Provides:	%kernel_modules_pkg >= %{kmod_kernel_version_min}.%{_target_cpu}
Provides:	kmod-%{kmod_name} = %{?epoch:%{epoch}:}%{version}-%{release}
Provides:       %{kmod_provides}
# if there are multiple kmods for the same driver from different vendors,
# they should conflict with each other.
Conflicts:	kmod-%{kmod_name}

# Set Requires: based on kernel version(s) installed
# "with" is important here: otherwise, ">=" and "<" parts maybe satisfied
# by different versions that are installed simultaneously (for example,
# 4.18.0-290 and 4.18.0-80, respectively).
Requires:	(%{kmod_rpm_name_ga} if (kernel >= %{kmod_kernel_version} with kernel < %{kmod_kernel_version_14_1}))
Requires:	(%{kmod_rpm_name_14_1} if kernel >= %{kmod_kernel_version_14_1})

%description
oracleasm kernel module

%package -n %{kmod_rpm_name_ga}
Summary:	oracleasm kernel module for kernel version %{kmod_kernel_version}..%{kmod_kernel_version_14_1}
Provides:	%kernel_modules_pkg >= %{kmod_kernel_version_14_1}.%{_target_cpu}
BuildRequires:	%kernel_devel_pkg = %kmod_kernel_version
Requires:	%{kmod_rpm_name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires(post):	%{sbindir}/weak-modules
Requires(postun):	%{sbindir}/weak-modules
Requires:	kernel >= %{kmod_kernel_version}

%description -n  %{kmod_rpm_name_ga}
oracleasm kernel module for kernel version %{kmod_kernel_version_14_1} and higher.

%package -n %{kmod_rpm_name_14_1}
Summary:	oracleasm kernel module for kernel version %{kmod_kernel_version_14_1} and higher
Provides:	%kernel_modules_pkg >= %{kmod_kernel_version_14_1}.%{_target_cpu}
## We can't have nice things (such as multiple kernel package versions in a brew
## buildroot despite its parallel installability, even), so we bundle it
## in Source1.
#BuildRequires:	%kernel_devel_pkg = %kmod_kernel_version_14_1
Requires:	%{kmod_rpm_name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires(post):	%{sbindir}/weak-modules
Requires(postun):	%{sbindir}/weak-modules
Requires:	kernel >= %{kmod_kernel_version_14_1}

%description -n  %{kmod_rpm_name_14_1}
oracleasm kernel module for kernel version %{kmod_kernel_version_14_1} and higher.

# Usage: kmod_scripts RPMNAME KVER
%define kmod_scripts() %{expand: \
%files -n %1 \
	%defattr(644,root,root,755) \
	/lib/modules/%2.%(arch) \
	%doc /usr/share/doc/%{kmod_rpm_name}/greylist.txt.%2 \
	\
%post -n %1 \
	kver="%2" \
	modules=( $(find /lib/modules/${kver}.%(arch)/%{kmod_install_path} | grep '\.ko$') ) \
	printf '%s\\n' "${modules[@]}" | %{sbindir}/weak-modules --add-modules --no-initramfs \
	\
	mkdir -p "%{kver_state_dir}" \
	touch "%{kver_state_dir}/${kver}.%(arch)" \
	\
	exit 0 \
	\
%posttrans -n %1 \
	# We have to re-implement part of weak-modules here because it doesn't allow \
	# calling initramfs regeneration separately \
	kver="%2" \
	kver_state_file="%{kver_state_dir}/${kver}.%(arch)" \
	if [ -f "${kver_state_file}" ]; then \
		kver_base="%{kmod_kernel_version_dep}" \
		kvers=$(ls -d "/lib/modules/${kver_base%%.*}"*) \
		\
		for k_dir in $kvers; do \
			k="${k_dir#/lib/modules/}" \
			\
			tmp_initramfs="/boot/initramfs-$k.tmp" \
			dst_initramfs="/boot/initramfs-$k.img" \
			\
			# The same check as in weak-modules: we assume that the kernel present \
			# if the symvers file exists. \
			if [ -e "/boot/symvers-$k.gz" ] || [ -e "$k_dir/symvers.gz" ]; then \
				/usr/bin/dracut -f "$tmp_initramfs" "$k" || exit 1 \
				cmp -s "$tmp_initramfs" "$dst_initramfs" \
				if [ "$?" = 1 ]; then \
					mv "$tmp_initramfs" "$dst_initramfs" \
				else \
					rm -f "$tmp_initramfs" \
				fi \
			fi \
		done \
		\
		rm -f "%{kver_state_dir}/${kver}.%(arch)" \
		rmdir "%{kver_state_dir}" 2> /dev/null \
	fi \
	\
	rmdir "%{dup_state_dir}" 2> /dev/null \
	\
	exit 0 \
	\
	\
%preun -n "%1" \
	if rpm -q --filetriggers kmod 2> /dev/null| grep -q "Trigger for weak-modules call on kmod removal"; then \
		kver="%2" \
		mkdir -p "%{kver_state_dir}" \
		touch "%{kver_state_dir}/${kver}.%(arch)" \
	fi \
	\
	mkdir -p "%{dup_state_dir}" \
	rpm -ql "%1-%{kmod_driver_version}-%{kmod_rpm_release}%{?dist}.%(arch)" | \\\
		grep '\\.ko$' > "%{dup_module_list}" \
	\
	exit 0 \
	\
	\
%postun -n %1 \
	if rpm -q --filetriggers kmod 2> /dev/null| grep -q "Trigger for weak-modules call on kmod removal"; then \
		initramfs_opt="--no-initramfs" \
	else \
		initramfs_opt="" \
	fi \
	\
	modules=( $(cat "%{dup_module_list}") ) \
	rm -f "%{dup_module_list}" \
	printf '%s\\n' "${modules[@]}" | %{sbindir}/weak-modules --remove-modules $initramfs_opt \
	\
	rmdir "%{dup_state_dir}" 2> /dev/null \
	\
	exit 0 \
}

%kmod_scripts %{kmod_rpm_name_ga} %{kmod_kernel_version}
%kmod_scripts %{kmod_rpm_name_14_1} %{kmod_kernel_version_14_1}


%files
%doc /usr/share/doc/%{kmod_rpm_name}/greylist.txt
/etc/depmod.d/%{kmod_name}.conf


%prep
# A hack for having directory name under builddir equivalent to RPM name
%setup -c
mv %{kmod_name}-%{kmod_vendor}-%{kmod_driver_version}/* .

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
set -- *
mkdir source
mv "$@" source/

# Unpacking bundled kernel-devel packages
for name_kver in %{kmod_list}; do
	src="${name_kver##*:}"
	[ -n "$src" ] || continue
	rpm2cpio "${src}" | cpio -idm
done

%build

for name_kver in %{kmod_list}; do
	kver="${name_kver#*:}"
	kver="${kver%%:*}"
	src="${name_kver##*:}"

	rm -rf obj.${kver}
	cp -r source obj.${kver}
	echo > source/greylist

	kernel_source="${src:+.}/usr/src/kernels/${kver}.%(arch)"
	kernel_source="$(realpath "${kernel_source}")"
	PWD_PATH=$(realpath --relative-to="${kernel_source}" . 2>/dev/null || echo "$PWD")
	%{make_build} -C ${kernel_source} V=1 M="$PWD_PATH/obj.${kver}/%{kmod_kbuild_dir}" \
		NOSTDINC_FLAGS="-I$PWD_PATH/obj.${kver}/include -I$PWD_PATH/obj.${kver}/include/uapi %{nil}" \
		EXTRA_CFLAGS="%{nil}" \
		%{nil}
	# mark modules executable so that strip-to-file can strip them
	find obj.${kver}/%{kmod_kbuild_dir} -name "*.ko" -type f -exec chmod u+x '{}' +

	whitelist="/lib/modules/kabi-current/kabi_whitelist_%{_target_cpu}"
	for modules in $( find obj.${kver}/%{kmod_kbuild_dir} -name "*.ko" -type f -printf "%{findpat}\n" | sed 's|\.ko$||' | sort -u ) ; do
		# update depmod.conf
		module_weak_path=$(echo "$modules" | sed 's/[\/]*[^\/]*$//')
		if [ -z "$module_weak_path" ]; then
			module_weak_path=%{name}
		else
			module_weak_path=%{name}/$module_weak_path
		fi
		echo "override $(echo $modules | sed 's/.*\///')" \
		     "$(echo "%{kmod_kernel_version_dep}" |
		        sed 's/\.[^\.]*$//;
			     s/\([.+?^$\/\\|()\[]\|\]\)/\\\0/g').*" \
			     "weak-updates/$module_weak_path" >> source/depmod.conf

		# update greylist
		nm -u obj.${kver}/%{kmod_kbuild_dir}/$modules.ko | sed 's/.*U //' |  sed 's/^\.//' | sort -u | while read -r symbol; do
			grep -q "^\s*$symbol\$" $whitelist || echo "$symbol" >> source/greylist
		done
	done
	sort -u source/greylist | uniq > source/greylist.txt.${kver}

	[ "x${kver}" != "x%{kmod_kernel_version}" ] || cp source/greylist.txt.${kver} source/greylist.txt
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%{kmod_install_path}

for name_kver in %{kmod_list}; do
	rpm_name="${name_kver%%%%:*}"
	kver="${name_kver#*:}"
	kver="${kver%%:*}"
	src="${name_kver##*:}"

	kernel_source="${src:+.}/usr/src/kernels/${kver}.%(arch)"
	kernel_source="$(realpath "${kernel_source}")"
	PWD_PATH=$(realpath --relative-to="${kernel_source}" . 2>/dev/null || echo "$PWD")
	make -C "${kernel_source}" V=1 modules_install \
		M=$PWD_PATH/obj.${kver}/%{kmod_kbuild_dir}

	install -m 644 -D source/greylist.txt.${kver} $RPM_BUILD_ROOT/usr/share/doc/%{kmod_rpm_name}/greylist.txt.${kver}
done

# Cleanup unnecessary kernel-generated module dependency files.
find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;

install -m 644 -D source/depmod.conf $RPM_BUILD_ROOT/etc/depmod.d/%{kmod_name}.conf
install -m 644 -D source/greylist.txt $RPM_BUILD_ROOT/usr/share/doc/%{kmod_rpm_name}/greylist.txt



%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Mar 24 2021 EL Errata <el-errata_ww@oracle.com> - 2.0.8-1.3.0.1

* Mon Mar 01 2021 Eugene Syromiatnikov <esyr@redhat.com> 2.0.8-1.3
- Replace "and" with "with" in pre-4.18.0-240.14.1.el8_3 kernel dependency
  to match it more precisely (it passes when both post-4.18.0-240.14.1.el8_3
  and pre-4.18.0-240.el8 kernels installed otherwise).

* Tue Feb 23 2021 Eugene Syromiatnikov <esyr@redhat.com> 2.0.8-1.2
- Build against kernel-4.18.0-240.14.1.el8_3 in addition to GA kernel
  (#1931546).

* Mon Feb 22 2021 Eugene Syromiatnikov <esyr@redhat.com> 2.0.8-1.1
- Check for symvers.gz presence in /lib/modules/KVER in addition to boot.

* Wed Dec 09 2020 Eugene Syromiatnikov <esyr@redhat.com> 2.0.8-1
- 19e841b848491d1e14dcd0063d8d681ed1190255
- oracleasm kernel module
- Resolves: #bz1904159
